include "Zeropage.inc"
include "Vram.inc"

SpriteCount equ 20
UnitSize equ 4
; Top equ 0

Patterns equ VicRam+$07F8
Positions equ $D000
UpperBits equ $D010
Flags equ $D015
Colors equ $D027
MaxSprites equ 8

dseg
Sprites: public Sprites
    defs UnitSize*SpriteCount
Sprites_x equ Sprites+0
Sprites_y equ Sprites+1
Sprites_color equ Sprites+2
Sprites_pattern equ Sprites+3
nextOffset defb 0

; void InitSprites()
cseg
InitSprites_: public InitSprites_
    pha
        lda #0
        sta nextOffset
    pla
    jsr HideAllSprites_
rts


; void ShowSprite(byte index, byte x, byte y, sbyte pattern, byte color);
dseg
ShowSprite_@Param0: public	ShowSprite_@Param0
ShowSprite_index:
    defb 0
ShowSprite_@Param1: public	ShowSprite_@Param1
ShowSprite_x:
    defb 0
ShowSprite_@Param2:	public	ShowSprite_@Param2
ShowSprite_y:
    defb 0
ShowSprite_@Param3: public	ShowSprite_@Param3
ShowSprite_pattern:
	defb 0
ShowSprite_@Param4: public	ShowSprite_@Param4
ShowSprite_color:
	defb 0
cseg
ShowSprite_: public	ShowSprite_
    pha
        lda ShowSprite_index
        asl a | asl a ; *4
        tax
        ; sei
            lda ShowSprite_x
            sta Sprites_x,x
            lda ShowSprite_y
            ; clc|adc #Top
            sta Sprites_y,x
            lda ShowSprite_pattern
            sta Sprites_pattern,x
            lda ShowSprite_color
            sta Sprites_color,x
        ; cli
    pla
rts


; void HideSprite(byte sprite);
dseg
HideSprite_@Param0: public HideSprite_@Param0
HideSprite_sprite:
    defb 0
cseg
HideSprite_: public HideSprite_
    pha
        lda HideSprite_sprite
        asl a | asl a ; *4
        tax
        lda #0
        ; sei
            sta Sprites_color,x
        ; cli
    pla
rts


; void HideAllSprites()
cseg
HideAllSprites_: public HideAllSprites_
    pha
        ; sei
            ldx #0
            ldy #SpriteCount
            lda #0
            do
                sta Sprites_color,x
                inx | inx | inx | inx
                dey
            while ne | wend
        ; cli
    pla
; jmp UpdateSprites_
rts


offset1 equ ZB0
offset2 equ ZB1
flag equ ZB2
cseg
UpdateSprites: public UpdateSprites
    pha
    lda <ZB0 | pha
    lda <ZB1 | pha
    lda <ZB2 | pha
    lda <ZB3 | pha
    lda <ZB4 | pha
        lda #0
        sta <offset1
        sta <offset2
        sta <ZB3
        sta <ZB4

        ldx nextOffset
        do
            lda Sprites_color,x ; color
        while eq
            inx | inx | inx | inx
            cpx #SpriteCount*UnitSize
            if eq
                ldx #0
            endif
            cpx nextOffset
            beq break1
        wend
        stx nextOffset

        lda #1
        sta <flag
        ldx nextOffset
        do
            lda Sprites_color,x ; color
            if ne
                ldy <offset1
                sta Colors,y
                lda Sprites_pattern,x  ; pattern
                sta Patterns,y
                iny
                sty <offset1
                
                ldy <offset2
                lda Sprites_x,x ; x
                clc|adc #24
                sta Positions+0,y ; x
                if cs
                    lda <ZB4
                    ora <flag
                    sta <ZB4
                endif
                lda Sprites_y,x ; y
                clc|adc #50
                sta Positions+1,y
                iny
                iny
                sty <offset2
                
                lda <ZB3
                ora <flag
                sta <ZB3
                
                asl <flag
                beq break2
            endif
            inx | inx | inx | inx
            cpx #SpriteCount*UnitSize
            if eq
                ldx #0
            endif
            cpx nextOffset
        while ne | wend
        break2:
        lda nextOffset
        clc|adc #UnitSize
        cmp #SpriteCount*UnitSize
        if eq
            lda #0
        endif
        sta nextOffset
        
        break1:
        lda <ZB3
        sta Flags
        lda <ZB4
        sta UpperBits
        exit:
    pla | sta <ZB4
    pla | sta <ZB3
    pla | sta <ZB2
    pla | sta <ZB1
    pla | sta <ZB0
    pla
rts
