#include "Star.h"
#include "Vram.h"
#include "Chars.h"
#include "Coord.h"

constexpr byte RangeY = 32;

struct Star {
    byte x, y;
};

static const Star[] Stars = {
	{ 1, 15 },
	{ 22, 3 },
	{ 22, 26 },
	{ 16, 8 },
	{ 14, 20 },
	{ 10, 0 },
	{ 5, 29 },
	{ 9, 14 },
	{ 24, 5 },
	{ 1, 20 },
	{ 27, 14 },
	{ 6, 30 },
	{ 1, 27 },
	{ 29, 22 },
	{ 5, 26 },
	{ 18, 19 },
};

static byte YOffset;
byte StarDotOffset;
byte StarChar;


void InitStarts()
{
    YOffset = 0;
    StarDotOffset = 0;
    StarChar = Char_Star;
    DrawStars();
}

void MoveStars()
{
    StarDotOffset += CoordRate / 4;
    if (StarDotOffset >= CharHeight) {
        StarDotOffset = 0;
        ++YOffset;
        BackgroundChanged = true;
    }
    else {
        UpdateStarChars();
    }
}


void DrawStars()
{
    ptr<Star> pStar;
    ++StarChar;
    if (StarChar >= Char_Star + 2) {
        StarChar = Char_Star;
    }
    UpdateStarChars();
    for (pStar : Stars) {
        byte x, y;
        x = pStar->x;
        y = (pStar->y + YOffset) & (RangeY - 1);
        if (y < WindowHeight) {
            *BackgroundPtr(x, y) = StarChar;
        }
    }
}
