#include "Vram.h"
#include "Chars.h"
#include "EnemyRow.h"
#include "Star.h"
#include "CopyMemory.h"

extern byte[] Chars, SpritePattern;

bool BackgroundChanged;
byte[256] CharColors;


void InitVram()
{
    InitCharColors();
    CopyMemory(PatternRam, Chars, PatternSize * Char_Star);
    {
        ptr<byte> pSource, pDestination;
        pSource = SpritePattern;
        pDestination = VicRam + (SpriteSize * Pattern_Enemy);
        InitSpritePatterns();
        // repeat(Pattern_End - Pattern_Enemy) {
        //     SetPattern(pDestination, pSource);
        //     pSource += PatternSize * 4;
        //     pDestination += SpriteSize;
        // }
    }
}


void ClearScreen()
{
    FillMemory(Vram, VramWidth * VramHeight, 0);
    FillMemory(ColorMap, VramWidth * VramHeight, 1);
}


ptr<byte> PrintC(ptr<byte> pVram, byte c)
{
    return Put(pVram, c - ' ');
}


ptr<byte> Put2C(ptr<byte> pVram, byte c)
{
    repeat (2) {
        repeat (2) {
            pVram = Put(pVram, c);
            ++c;
        }
        pVram += VramRowSize - 2 * VramStep;
    }
    return pVram + 2 * VramStep - VramRowSize * 2;
}


ptr<byte> Erase2(ptr<byte> pVram)
{
    repeat (2) {
        repeat (2) {
            pVram = Put(pVram, Char_Space);
        }
        pVram += VramRowSize - 2 * VramStep;
    }
    return pVram + 2 * VramStep - VramRowSize * 2;
}


void DrawAll() {
    if (BackgroundChanged) {
        BackgroundChanged = false;
        ClearBackground();
        DrawStars();
        DrawEnemyRows();
        BackgroundToVram();
    }
}
