constexpr ptr<byte> VicRam = (ptr<byte>)0x8000;
constexpr ptr<byte> Vram = VicRam + 0x400;
constexpr ptr<byte> PatternRam = VicRam + 0x800;
constexpr ptr<byte> ColorMap = (ptr<byte>)0xd800;

constexpr byte VramWidth = 40;
constexpr byte VramHeight = 25;
constexpr byte VramRowSize = VramWidth;
constexpr byte CharHeight = 8;
constexpr byte VramStep = 1;
constexpr byte PatternSize = CharHeight;
constexpr byte SpriteSize = 64;

constexpr byte WindowWidth = 32;
constexpr byte WindowHeight = VramHeight;

extern bool BackgroundChanged;
extern byte[] Background;

extern void InitCharColors();
extern void InitSpritePatterns();
extern ptr<byte> Put(ptr<byte> pVram, byte c);
extern void ClearBackground();
extern void BackgroundToVram();
extern ptr<byte> BackgroundPtr(byte x, byte y);
extern void UpdateEnemyChars();
extern void UpdateStarChars();

extern void InitVram();
extern void ClearScreen();
extern ptr<byte> PrintC(ptr<byte> pVram, byte c);
extern ptr<byte> Put2C(ptr<byte> pVram, byte c);
extern ptr<byte> Erase2(ptr<byte> pVram);
extern void DrawAll();
